Index: lang/en_utf8/grades.php
=========================================================
--- lang/en_utf8/grades.php	(revision 1.111.2.60)
+++ lang/en_utf8/grades.php	Thu Apr 16 09:31:42 CEST 2009
@@ -11,6 +11,8 @@
 $string['addidnumbers'] = 'Add id numbers';
 $string['additem'] = 'Add grade item';
 $string['addoutcomeitem'] = 'Add outcome item';
+$string['addoutcome'] = 'Add an outcome';
+$string['addscale'] = 'Add a scale';
 $string['aggregateextracreditmean'] = 'Mean of grades (with extra credits)';
 $string['aggregatemean'] = 'Mean of grades';
 $string['aggregatemedian'] = 'Median of grades';
@@ -37,6 +39,8 @@
 $string['aggregationcoefweighthelp'] = 'Weight applied to all grades in this grade item during aggregation with other grade items.';
 $string['aggregationhelp'] = 'Strategy used to aggregate grades across all students in a course.';
 $string['aggregationposition'] = 'Aggregation position';
+$string['aggregationsvisible'] = 'Available aggregation types';
+$string['aggregationsvisiblehelp'] = 'Select all aggregation types that should be available. Hold down the Ctrl key to select multiple items.';
 $string['aggregationview'] = 'Aggregation view';
 $string['allgrades'] = 'All grades by category';
 $string['allstudents'] = 'All students';
@@ -48,9 +52,12 @@
 $string['averagesdisplaytype'] = 'Column averages display type';
 $string['backupwithoutgradebook'] = 'Backup does not contain Gradebook configuration';
 $string['badgrade'] = 'Supplied grade is invalid';
+$string['badlyformattedscale'] = 'Please enter a comma-separated list of values (at least two values required).';
 $string['baduser'] = 'Supplied user is invalid';
 $string['bonuspoints'] = 'Bonus points';
+$string['combo'] = 'Tabs and Dropdown menu';
 $string['bulkcheckboxes'] = 'Bulk checkboxes';
+$string['calculatedgrade'] = 'Calculated grade';
 $string['calculation'] = 'Calculation';
 $string['calculationadd'] = 'Add calculation';
 $string['calculationedit'] = 'Edit calculation';
@@ -63,6 +70,7 @@
 $string['categoryedit'] = 'Edit category';
 $string['categoryname'] = 'Category name';
 $string['categorytotal'] = 'Category total';
+$string['categorytotalfull'] = '$a->category total';
 $string['changereportdefaults'] = 'Change report defaults';
 $string['changedefaults'] = 'Change defaults';
 $string['choosecategory'] = 'Select category';
@@ -77,6 +85,7 @@
 $string['configdecimalpoints'] = 'Specifies the number of decimal points to display for each grade. This setting may be overridden per grading item.';
 $string['configenableajax'] = 'Adds a layer of AJAX functionality to the grader report, simplifying and speeding up common operations. Depends on Javascript being switched on at the user\'s browser level.';
 $string['configenableoutcomes'] = 'Support for Outcomes (also known as Competencies, Goals, Standards or Criteria) means that we can grade things using one or more scales that are tied to outcome statements. Enabling outcomes makes such special grading possible throughout the site.';
+$string['configfixedstudents'] = 'Allows grades to scroll horizontally without losing sight of the students column, by making it static.';
 $string['configgradeboundary'] = 'A percentage boundary over which grades will be assigned a grade letter (if the Letter grade display type is used). ';
 $string['configgradedisplaytype'] = 'Specifies how to display grades in the grader and user reports. Grades may be shown as actual grades, as percentages (in reference to the minimum and maximum grades) or as letters.';
 $string['configgradeexportdisplaytype'] = 'Grades can be shown as real grades, as percentages (in reference to the minimum and maximum grades) or as letters (A, B, C etc..) during export. This can be overridden during export.';
@@ -111,17 +120,21 @@
 $string['configshowuserimage'] = 'Whether to show the user\'s profile image next to the name in the grader report.';
 $string['configstudentsperpage'] = 'The number of students to display per page in the grader report.';
 $string['configstudentsperpagedefault'] = 'The number of students to display per page in the grader report. Leave this field empty to use the site default (currently $a).';
+$string['configunlimitedgrades'] = 'By default grades are limited by the maximum and minimum values of the grade item. Enabling this setting removes this limit, and allows grades of over 100%% to be entered directly in the gradebook. It is recommended that this setting is enabled at an off-peak time, as all grades will be recalculated, which may result in a high server load.';
 $string['contract'] = 'Contract Category';
 $string['controls'] = 'Controls';
 $string['coursegradecategory'] = 'Course grade category';
 $string['coursegradedisplaytype'] = 'Course grade display type';
 $string['coursegradedisplayupdated'] = 'The course grade display type has been updated.';
 $string['coursename'] = 'Course name';
+$string['coursescales'] = 'Course scales';
 $string['coursesettings'] = 'Course settings';
+$string['coursesettingsexplanation'] = 'Course settings determine how the gradebook appears for all participants in the course.';
 $string['coursetotal'] = 'Course total';
 $string['createcategory'] = 'Create category';
 $string['createcategoryerror'] = 'Could not create a new category';
 $string['creatinggradebooksettings'] = 'Creating gradebook settings';
+$string['currentparentaggregation'] = 'Current parent aggregation';
 $string['csv'] = 'CSV';
 $string['curveto'] = 'Curve to';
 $string['decimalpoints'] = 'Overall decimal points';
@@ -133,6 +146,7 @@
 $string['displaypercent'] = 'Display percents';
 $string['displaypoints'] = 'Display points';
 $string['displayweighted'] = 'Display weighted grades';
+$string['dropdown'] = 'Dropdown menu';
 $string['droplow'] = 'Drop the lowest';
 $string['droplowhelp'] = 'If set, this option will drop the X lowest grades, X being the selected value for this option.';
 $string['dropped'] = 'Dropped';
@@ -144,7 +158,10 @@
 $string['editcalculationverbose'] = 'Edit calculation for $a->category$a->itemmodule $a->itemname';
 $string['editfeedback'] = 'Edit feedback';
 $string['editgrade'] = 'Edit grade';
+$string['editgradeletters'] = 'Edit grade letters';
+$string['editoutcome'] = 'Edit outcome';
 $string['editoutcomes'] = 'Edit outcomes';
+$string['editscale'] = 'Edit scale';
 $string['edittree'] = 'Categories and items';
 $string['editverbose'] = 'Edit $a->category$a->itemmodule $a->itemname';
 $string['enableajax'] = 'Enable AJAX';
@@ -177,12 +194,14 @@
 $string['feedbacksaved'] = 'Feedback saved';
 $string['finalgrade'] = 'Final grade';
 $string['finalgradehelp'] = 'The final grade (cached) after all calculations are performed.';
+$string['fixedstudents'] = 'Static students column';
 $string['forceoff'] = 'Force: Off';
 $string['forceon'] = 'Force: On';
 $string['forelementtypes'] = ' for the selected $a';
 $string['forstudents'] = 'For students';
 $string['full'] = 'Full';
 $string['fullmode'] = 'Full view';
+$string['fullview'] = 'Full view';
 $string['generalsettings'] = 'General settings';
 $string['grade'] = 'Grade';
 $string['gradebook'] = 'Gradebook';
@@ -200,6 +219,7 @@
 $string['gradeexceptionshelp'] = 'Grade exceptions Help';
 $string['gradeexportdisplaytype'] = 'Grade export display type';
 $string['gradeexportdecimalpoints'] = 'Grade export decimal points';
+$string['gradeforstudent'] = '$a->student<br />$a->item$a->feedback';
 $string['gradehelp'] = 'Grade Help';
 $string['gradehistorylifetime'] = 'Grade history lifetime';
 $string['gradeitem'] = 'Grade item';
@@ -286,6 +306,7 @@
 $string['incorrectcourseid'] = 'Course ID was incorrect';
 $string['incorrectminmax'] = 'The minimum must be lower than the maximum';
 $string['inherit'] = 'Inherit';
+$string['intersectioninfo'] = 'Student/Grade info';
 $string['item'] = 'Item';
 $string['iteminfo'] = 'Item info';
 $string['iteminfohelp'] = 'A space for entering information about the item. Text entered does not appear anywhere else.';
@@ -305,6 +326,7 @@
 $string['letters'] = 'Letters';
 $string['linkedactivity'] = 'Linked activity';
 $string['linkedactivityhelp'] = 'Specifies an optional activity to which this outcome item is linked. This is used to measure student performance on criteria not assessed by the activity grade.';
+$string['linktoactivity'] = 'Link to $a->name activity';
 $string['lock'] = 'Lock';
 $string['locked'] = 'Locked';
 $string['locktime'] = 'Lock after';
@@ -326,12 +348,17 @@
 $string['missingscale'] = 'Scale must be selected';
 $string['mode'] = 'Mode';
 $string['morethanmax'] = 'The grade entered for $a->itemname for $a->username is more than the maximum allowed';
+$string['moveselectedto'] = 'Move selected items to:';
 $string['movingelement'] = 'Moving $a';
 $string['multfactor'] = 'Multiplicator';
 $string['multfactorhelp'] = 'Factor by which all grades for this grade item will be multiplied.';
+$string['mypreferences'] = 'My preferences';
 $string['myreportpreferences'] = 'My report preferences';
+$string['navmethod'] = 'Navigation method';
 $string['neverdeletehistory'] = 'Never delete history';
 $string['newcategory'] = 'New category';
+$string['newitem'] = 'New grade item';
+$string['newoutcomeitem'] = 'New outcome item';
 $string['newuserkey'] = 'New user key';
 $string['no'] = 'No';
 $string['nocategories'] = 'Grade categories could not be added or found for this course';
@@ -473,6 +500,7 @@
 $string['showuseridnumber'] = 'Show user idnumber';
 $string['showuserimage'] = 'Show user profile images';
 $string['showverbose'] = 'Show $a->category$a->itemmodule $a->itemname';
+$string['simpleview'] = 'Simple view';
 $string['sitewide'] = 'Site-wide';
 $string['sort'] = 'sort';
 $string['sortasc'] = 'Sort in ascending order';
@@ -487,7 +515,10 @@
 $string['subcategory'] = 'Normal category';
 $string['submissions'] = 'Submissions';
 $string['submittedon'] = 'Submitted: $a';
+$string['switchtofullview'] = 'Switch to full view';
+$string['switchtosimpleview'] = 'Switch to simple view';
 $string['synclegacygrades'] = 'Synchronise legacy grades';
+$string['tabs'] = 'Tabs';
 $string['topcategory'] = 'Super category';
 $string['total'] = 'Total';
 $string['totalweight100'] = 'The total weight is equal to 100';
@@ -502,6 +533,7 @@
 $string['uncategorised'] = 'Uncategorised';
 $string['unchangedgrade'] = 'Grade unchanged';
 $string['unenrolledusersinimport'] = 'This import included the following grades for users not currently enrolled in this course: $a';
+$string['unlimitedgrades'] = 'Unlimited grades';
 $string['unlock'] = 'Unlock';
 $string['unlockverbose'] = 'Unlock $a->category$a->itemmodule $a->itemname';
 $string['unused'] = 'Unused';
@@ -521,11 +553,15 @@
 $string['viewbygroup'] = 'Group';
 $string['viewgrades'] = 'View grades';
 $string['weight'] = 'weight';
+$string['weightuc'] = 'Weight';
 $string['weightcourse'] = 'Use weighted grades for course';
 $string['weightedascending'] = 'Sort by weighted percent ascending';
 $string['weighteddescending'] = 'Sort by weighted percent descending';
 $string['weightedpct'] = 'weighted %%';
 $string['weightedpctcontribution'] = 'weighted %% contribution';
+$string['weightorextracredit'] = 'Weight or extra credit';
+$string['weights'] = 'Weights';
+$string['weightsedit'] = 'Edit weights and extra credits';
 $string['writinggradebookinfo'] = 'Writing gradebook settings';
 $string['xml'] = 'XML';
 $string['yes'] = 'Yes';
Index: lib/adminlib.php
=========================================================
--- lib/adminlib.php	(revision 1.153.2.72)
+++ lib/adminlib.php	Thu Apr 16 09:31:42 CEST 2009
@@ -3495,6 +3495,35 @@
     }
 }
 
+class admin_setting_special_gradelimiting extends admin_setting_configcheckbox {
+    function admin_setting_special_gradelimiting() {
+        parent::admin_setting_configcheckbox('unlimitedgrades', get_string('unlimitedgrades', 'grades'),
+                                                  get_string('configunlimitedgrades', 'grades'), '0', '1', '0');
+    }
+
+    function regrade_all() {
+        global $CFG;
+        require_once("$CFG->libdir/gradelib.php");
+        grade_force_site_regrading();
+    }
+
+    function write_setting($data) {
+        $previous = $this->get_setting();
+
+        if ($previous === null) {
+            if ($data) {
+                $this->regrade_all();
+            }
+        } else {
+            if ($data != $previous) {
+                $this->regrade_all();
+            }
+        }
+        return ($this->config_write($this->name, $data) ? '' : get_string('errorsetting', 'admin'));
+    }
+
+}
+
 /**
  * Primary grade export plugin - has state tracking.
  */
Index: lib/grade/constants.php
=========================================================
--- lib/grade/constants.php	(revision 1.7.2.3)
+++ lib/grade/constants.php	Thu Apr 16 09:31:42 CEST 2009
@@ -85,4 +85,8 @@
 
 define('GRADE_REPORT_MEAN_ALL', 0);
 define('GRADE_REPORT_MEAN_GRADED', 1);
+
+define('GRADE_NAVMETHOD_DROPDOWN', 0);
+define('GRADE_NAVMETHOD_TABS', 1);
+define('GRADE_NAVMETHOD_COMBO', 2);
 ?>
Index: lib/grade/grade_category.php
=========================================================
--- lib/grade/grade_category.php	(revision 1.96.2.23)
+++ lib/grade/grade_category.php	Thu Apr 16 09:31:42 CEST 2009
@@ -144,6 +144,11 @@
     var $forceable = array('aggregation', 'keephigh', 'droplow', 'aggregateonlygraded', 'aggregateoutcomes', 'aggregatesubcats');
 
     /**
+     * String representing the aggregation coefficient. Variable is used as cache.
+     */
+    var $coefstring = null;
+
+    /**
      * Builds this category's path string based on its parents (if any) and its own id number.
      * This is typically done just before inserting this object in the DB for the first time,
      * or when a new parent is added or changed. It is a recursive function: once the calling
@@ -567,11 +572,7 @@
         // recalculate the grade back to requested range
         $finalgrade = grade_grade::standardise_score($agg_grade, 0, 1, $this->grade_item->grademin, $this->grade_item->grademax);
 
-        if (is_null($finalgrade)) {
-            $grade->finalgrade = null;
-        } else {
-            $grade->finalgrade = (float)bounded_number($this->grade_item->grademin, $finalgrade, $this->grade_item->grademax);
-        }
+        $grade->finalgrade = $this->grade_item->bounded_grade($finalgrade);
 
         // update in db if changed
         if (grade_floats_different($grade->finalgrade, $oldfinalgrade)) {
@@ -769,7 +770,7 @@
         $this->apply_limit_rules($grade_values);
 
         $sum = array_sum($grade_values);
-        $grade->finalgrade = bounded_number($this->grade_item->grademin, $sum, $this->grade_item->grademax);
+        $grade->finalgrade = $this->grade_item->bounded_grade($sum);
 
         // update in db if changed
         if (grade_floats_different($grade->finalgrade, $oldfinalgrade)) {
@@ -811,6 +812,52 @@
     }
 
     /**
+     * Recursive function to find which weight/extra credit field to use in the grade item form. Inherits from a parent category
+     * if that category has aggregatesubcats set to true.
+     * @param string $coefstring
+     * @return string $coefstring
+     */
+    function get_coefstring($first=true) {
+        if (!is_null($this->coefstring)) {
+            return $this->coefstring;
+        }
+
+        $overriding_coefstring = null;
+
+        // Stop recursing upwards if this category aggregates subcats or has no parent
+        if (!$first && !$this->aggregatesubcats) {
+            if ($parent_category = $this->get_parent_category()) {
+                return $parent_category->get_coefstring(false);
+            } else {
+                return null;
+            }
+        } elseif ($first) {
+            if (!$this->aggregatesubcats) {
+                if ($parent_category = $this->get_parent_category()) {
+                    $overriding_coefstring = $parent_category->get_coefstring(false);
+                }
+            }
+        }
+
+        // If an overriding coefstring has trickled down from one of the parent categories, return it. Otherwise, return self.
+        if (!is_null($overriding_coefstring)) {
+            return $overriding_coefstring;
+        }
+
+        // No parent category is overriding this category's aggregation, return its string
+        if ($this->aggregation == GRADE_AGGREGATE_WEIGHTED_MEAN) {
+            $this->coefstring = 'aggregationcoefweight';
+        } else if ($this->aggregation == GRADE_AGGREGATE_EXTRACREDIT_MEAN) {
+            $this->coefstring = 'aggregationcoefextra';
+        } else if ($this->aggregation == GRADE_AGGREGATE_SUM) {
+            $this->coefstring = 'aggregationcoefextrasum';
+        } else {
+            $this->coefstring = 'aggregationcoef';
+        }
+        return $this->coefstring;
+    }
+
+    /**
      * Returns tree with all grade_items and categories as elements
      * @static
      * @param int $courseid
Index: lib/grade/grade_grade.php
=========================================================
--- lib/grade/grade_grade.php	(revision 1.14.2.18)
+++ lib/grade/grade_grade.php	Thu Apr 16 09:31:42 CEST 2009
@@ -436,7 +436,7 @@
             return $this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time());
         } else {
             return $this->hidden == 1 or ($this->hidden != 0 and $this->hidden > time()) or $this->grade_item->is_hidden();
-        } 
+        }
     }
 
     /**
@@ -622,7 +622,7 @@
                             foreach ($dependson[$do] as $itemid) {
                                 if (array_key_exists($itemid, $altered)) {
                                     $values[$itemid] = $altered[$itemid];
-                                } else {
+                                } elseif (!empty($values[$itemid])) {
                                     $values[$itemid] = $grade_grades[$itemid]->finalgrade;
                                 }
                             }
@@ -667,9 +667,7 @@
                             // recalculate the rawgrade back to requested range
                             $finalgrade = grade_grade::standardise_score($agg_grade, 0, 1, $grade_items[$do]->grademin, $grade_items[$do]->grademax);
 
-                            if (!is_null($finalgrade)) {
-                                $finalgrade = bounded_number($grade_items[$do]->grademin, $finalgrade, $grade_items[$do]->grademax);
-                            }
+                            $finalgrade = $grade_items[$do]->bounded_grade($finalgrade);
 
                             $altered[$do] = $finalgrade;
                             unset($todo[$key]);
@@ -716,8 +714,8 @@
     }
 
     function insert($source=null) {
-        // TODO: dategraded hack - do not update times, they are used for submission and grading  
-        //$this->timecreated = $this->timemodified = time(); 
+        // TODO: dategraded hack - do not update times, they are used for submission and grading
+        //$this->timecreated = $this->timemodified = time();
         return parent::insert($source);
     }
 
Index: lib/grade/grade_item.php
=========================================================
--- lib/grade/grade_item.php	(revision 1.130.2.30)
+++ lib/grade/grade_item.php	Thu Apr 16 09:31:42 CEST 2009
@@ -735,7 +735,7 @@
             $rawgrade *= $this->multfactor;
             $rawgrade += $this->plusfactor;
 
-            return bounded_number($this->grademin, $rawgrade, $this->grademax);
+            return $this->bounded_grade($rawgrade);
 
         } else if ($this->gradetype == GRADE_TYPE_SCALE) { // Dealing with a scale value
             if (empty($this->scale)) {
@@ -756,7 +756,7 @@
                 $rawgrade = grade_grade::standardise_score($rawgrade, $rawmin, $rawmax, $this->grademin, $this->grademax);
             }
 
-            return (int)bounded_number(0, round($rawgrade+0.00001), $this->grademax);
+            return $this->bounded_grade($rawgrade);
 
 
         } else if ($this->gradetype == GRADE_TYPE_TEXT or $this->gradetype == GRADE_TYPE_NONE) { // no value
@@ -1163,9 +1163,10 @@
     /**
      * Returns the most descriptive field for this object. This is a standard method used
      * when we do not know the exact type of an object.
+     * @param boolean $fulltotal: if the item is a category total, returns $categoryname."total" instead of "Category total" or "Course total"
      * @return string name
      */
-    function get_name() {
+    function get_name($fulltotal=false) {
         if (!empty($this->itemname)) {
             // MDL-10557
             return format_string($this->itemname);
@@ -1174,7 +1175,14 @@
             return get_string('coursetotal', 'grades');
 
         } else if ($this->is_category_item()) {
+            if ($fulltotal) {
+                $category = $this->get_parent_category();
+                $a = new stdClass();
+                $a->category = $category->get_name();
+                return get_string('categorytotalfull', 'grades', $a);
+            } else {
-            return get_string('categorytotal', 'grades');
+                return get_string('categorytotal', 'grades');
+            }
 
         } else {
             return get_string('grade');
@@ -1210,6 +1218,43 @@
     }
 
     /**
+     * Makes sure value is a valid grade value.
+     * @param float $gradevalue
+     * @return mixed float or int fixed grade value
+     */
+    function bounded_grade($gradevalue) {
+        global $CFG;
+
+        if (is_null($gradevalue)) {
+            return null;
+        }
+
+        if ($this->gradetype == GRADE_TYPE_SCALE) {
+            // no >100% grades hack for scale grades!
+            // 1.5 is rounded to 2 ;-)
+            return (int)bounded_number($this->grademin, round($gradevalue+0.00001), $this->grademax);
+        }
+
+        $grademax = $this->grademax;
+
+        // NOTE: if you change this value you must manually reset the needsupdate flag in all grade items
+        $maxcoef = isset($CFG->gradeoverhundredprocentmax) ? $CFG->gradeoverhundredprocentmax : 10; // 1000% max by default
+
+        if (!empty($CFG->unlimitedgrades)) {
+            // NOTE: if you change this value you must manually reset the needsupdate flag in all grade items
+            $grademax = $grademax * $maxcoef;
+        } else if ($this->is_category_item() or $this->is_course_item()) {
+            $category = $this->load_item_category();
+            if ($category->aggregation >= 100) {
+                // grade >100% hack
+                $grademax = $grademax * $maxcoef;
+            }
+        }
+
+        return (float)bounded_number($this->grademin, $gradevalue, $grademax);
+    }
+
+    /**
      * Finds out on which other items does this depend directly when doing calculation or category agregation
      * @param bool $reset_cache
      * @return array of grade_item ids this one depends on
@@ -1388,11 +1433,7 @@
                 $grade->overridden = 0;
             }
 
-            if (is_null($finalgrade)) {
-                $grade->finalgrade = null;
-            } else {
-                $grade->finalgrade = bounded_number($this->grademin, $finalgrade, $this->grademax);
-            }
+            $grade->finalgrade = $this->bounded_grade($finalgrade);
         }
 
         // do we have comment from teacher?
@@ -1735,11 +1776,7 @@
 
         } else {
             // normalize
-            $result = bounded_number($this->grademin, $result, $this->grademax);
-            if ($this->gradetype == GRADE_TYPE_SCALE) {
-                $result = round($result+0.00001); // round scales upwards
-            }
-            $grade->finalgrade = $result;
+            $grade->finalgrade = $this->bounded_grade($result);
         }
 
         // update in db if changed
@@ -1908,5 +1945,21 @@
         return $grademin.'&ndash;'. $grademax;
     }
 
+    /**
+     * Queries parent categories recursively to find the aggregationcoef type that applies to this
+     * grade item.
+     */
+    function get_coefstring() {
+        $parent_category = $this->get_parent_category();
+        if ($this->is_category_item()) {
+            $parent_category = $parent_category->get_parent_category();
+        }
+
+        if ($parent_category->is_aggregationcoef_used()) {
+            return $parent_category->get_coefstring();
+        } else {
+            return false;
+        }
+    }
 }
 ?>
Index: lib/gradelib.php
=========================================================
--- lib/gradelib.php	(revision 1.120.2.27)
+++ lib/gradelib.php	Thu Apr 16 09:31:42 CEST 2009
@@ -706,7 +706,7 @@
             return get_string('error');
         }
 
-        $value = (int)bounded_number($grade_item->grademin, $value, $grade_item->grademax);
+        $value = $grade_item->bounded_grade($value);
         return format_string($scale->scale_items[$value-1]);
 
     } else {
@@ -720,7 +720,7 @@
     if ($min == $max) {
         return '';
     }
-    $value = bounded_number($min, $value, $max);
+    $value = $grade_item->bounded_grade($value);
     $percentage = (($value-$min)*100)/($max-$min);
     return format_float($percentage, $decimals, $localized).' %';
 }
@@ -731,6 +731,10 @@
         return ''; // no letters??
     }
 
+    if (is_null($value)) {
+        return '-';
+    }
+
     $value = grade_grade::standardise_score($value, $grade_item->grademin, $grade_item->grademax, 0, 100);
     $value = bounded_number(0, $value, 100); // just in case
     foreach ($letters as $boundary => $letter) {
@@ -862,6 +866,15 @@
 }
 
 /**
+ * Forces regrading of all site grades - usualy when chanign site setings
+ */
+function grade_force_site_regrading() {
+    global $CFG;
+    $sql = "UPDATE {$CFG->prefix}grade_items SET needsupdate=1";
+    execute_sql($sql);
+}
+
+/**
  * Updates all final grades in course.
  *
  * @param int $courseid
@@ -1069,7 +1082,7 @@
 
     $fullmod = $CFG->dirroot.'/mod/'.$modinstance->modname;
     if (!file_exists($fullmod.'/lib.php')) {
-        debugging('missing lib.php file in module');
+        debugging('missing lib.php file in module ' . $modinstance->modname);
         return false;
     }
     include_once($fullmod.'/lib.php');
Index: lib/moodlelib.php
=========================================================
--- lib/moodlelib.php	(revision 1.960.2.126)
+++ lib/moodlelib.php	Thu Apr 16 09:31:42 CEST 2009
@@ -790,7 +790,7 @@
 
 /**
  * Use this funciton to get a list of users from a config setting of type admin_setting_users_with_capability.
- * @param string $value the value of the config setting. 
+ * @param string $value the value of the config setting.
  * @param string $capability the capability - must match the one passed to the admin_setting_users_with_capability constructor.
  * @return array of user objects.
  */
@@ -6327,6 +6327,39 @@
 }
 
 /**
+ * Returns one or several CSS class names that match the user's browser. These can be put
+ * in the body tag of the page to apply browser-specific rules without relying on CSS hacks
+ */
+function get_browser_version_classes() {
+    $classes = '';
+    if (check_browser_version("MSIE", "0")) {
+        $classes .= 'ie ';
+        if (check_browser_version("MSIE", 8)) {
+            $classes .= 'ie8 ';
+        } elseif (check_browser_version("MSIE", 7)) {
+            $classes .= 'ie7 ';
+        } elseif (check_browser_version("MSIE", 6)) {
+            $classes .= 'ie6 ';
+        }
+    } elseif (check_browser_version("Firefox", 0) || check_browser_version("Gecko", 0) || check_browser_version("Camino", 0)) {
+        $classes .= 'gecko ';
+
+        if (preg_match('/rv\:([1-2])\.([0-9])/', $_SERVER['HTTP_USER_AGENT'], $matches)) {
+            $classes .= "gecko{$matches[1]}{$matches[2]} ";
+        }
+
+    } elseif (check_browser_version("Safari", 0)) {
+        $classes .= 'safari ';
+
+    } elseif (check_browser_version("Opera", 0)) {
+        $classes .= 'opera ';
+
+    }
+
+    return $classes;
+}
+
+/**
  * This function makes the return value of ini_get consistent if you are
  * setting server directives through the .htaccess file in apache.
  * Current behavior for value set from php.ini On = 1, Off = [blank]
